CREATE TABLE WORKER_TASK_STATUS (
  ID_WORKER_TASK_STATUS NUMBER NOT NULL,
  DESCRIPTION VARCHAR2(200 CHAR),
  COLOR_PLAN VARCHAR2(20 CHAR),
  TEXT_COLOR_PLAN VARCHAR2(20 CHAR),
  COLOR_ACTUAL VARCHAR2(20 CHAR),
  TEXT_COLOR_ACTUAL VARCHAR2(20 CHAR),
  ACTIVE VARCHAR2(1 CHAR),
  CONSTRAINT WORKER_TASK_STATUS_PK PRIMARY KEY (ID_WORKER_TASK_STATUS)
);

INSERT INTO WORKER_TASK_STATUS(ID_WORKER_TASK_STATUS, DESCRIPTION, COLOR_PLAN, TEXT_COLOR_PLAN, COLOR_ACTUAL, TEXT_COLOR_ACTUAL, ACTIVE) VALUES
(1, 'Open', '0,255,255', '0,0,0', '0,255,0', '0,0,0',  'Y');

INSERT INTO WORKER_TASK_STATUS(ID_WORKER_TASK_STATUS, DESCRIPTION, COLOR_PLAN, TEXT_COLOR_PLAN, COLOR_ACTUAL, TEXT_COLOR_ACTUAL, ACTIVE) VALUES
(2, 'Approved', '0,180,180', '0,0,0', '0,180,0', '0,0,0',  'Y');

CREATE SEQUENCE WORKER_TASK_STATUS_SEQ MINVALUE 1 INCREMENT BY 1 START WITH 20 NOCACHE NOORDER  NOCYCLE;

ALTER TABLE DELAVCI
ADD STATUS_PLAN NUMBER DEFAULT 1 CONSTRAINT DELAVCI_STATUS_PLAN_FK REFERENCES WORKER_TASK_STATUS(ID_WORKER_TASK_STATUS);

ALTER TABLE DELAVCI
ADD STATUS_ACTUAL NUMBER DEFAULT 1 CONSTRAINT DELAVCI_STATUS_ACTUAL_FK REFERENCES WORKER_TASK_STATUS(ID_WORKER_TASK_STATUS);

ALTER TABLE DELAVCI
ADD DATE_APPROVED_PLAN DATE;

ALTER TABLE DELAVCI
ADD USER_APPROVED_PLAN VARCHAR2(20 CHAR);

ALTER TABLE DELAVCI
ADD DATE_APPROVED_ACTUAL DATE;

ALTER TABLE DELAVCI
ADD USER_APPROVED_ACTUAL VARCHAR2(20 CHAR);

DROP VIEW V_DELAVCI;

CREATE OR REPLACE VIEW V_DELAVCI AS (
	SELECT D.ID_DELAVCI, D.ID_STORITVE, D.SIFRA, D.DATUM, D.STEVILO_UR, D.HOURS_PLANNED, D.KOMENTAR, D.HOUR_FROM_PLANNED, D.ID_TIPSERVIS,
  TSP.DESCRIPTION AS STATUS_PLAN_DESCRIPTION, TSP.COLOR_PLAN AS STATUS_PLAN_COLOR, TSP.TEXT_COLOR_PLAN AS STATUS_PLAN_TEXT_COLOR, 
  TSA.DESCRIPTION AS STATUS_ACTUAL_DESCRIPTION, TSA.COLOR_ACTUAL AS STATUS_ACTUAL_COLOR, TSA.TEXT_COLOR_ACTUAL AS STATUS_ACTUAL_TEXT_COLOR, 
  MS.ID_DN, MNS.OPIS AS NNSTOMAR_OPIS, ND.OPIS AS NNDELAVC_OPIS, ND.INTERNI_OPIS AS NNDELAVC_INTERNI_OPIS, ND.PRICE AS NNDELAVC_PRICE, ND.TYPE AS NNDELAVC_TYPE, ND.NNLOCATION_ID AS NNDELAVC_NNLOCATION_ID, ND.ID AS NNDELAVC_ID, 
  KD.IME AS NNDELAVC_KUPCI_IME, KD.PRIIMEK AS NNDELAVC_KUPCI_PRIIMEK, KD.MANAGER AS NNDELAVC_KUPCI_MANAGER,
  TS.OPIS AS TIPSERVIS_OPIS, TS.INTERNAL AS TIPSERVIS_INTERNAL, MT.ID_MAINTENANCE_TASK AS MAINTENANCE_TASK_ID, MT.ID_CHECKLIST AS MAINTENANCE_TASK_ID_CHECKLIST,
  TO_DATE(TO_CHAR(D.DATUM,'YYYYMMDD') || (CASE WHEN D.HOUR_FROM_PLANNED IS NULL THEN (SELECT VREDNOST FROM S_NASTAVITVE WHERE NAZIV = 'WorkerTimesheetTimeFrom') ELSE D.HOUR_FROM_PLANNED END), 'YYYYMMDDHH24:MI') AS DATE_FROM_PLANNED,
  TO_DATE(TO_CHAR(D.DATUM,'YYYYMMDD') || (CASE WHEN D.HOUR_FROM_PLANNED IS NULL THEN (SELECT VREDNOST FROM S_NASTAVITVE WHERE NAZIV = 'WorkerTimesheetTimeFrom') ELSE D.HOUR_FROM_PLANNED END), 'YYYYMMDDHH24:MI') + D.HOURS_PLANNED/24 AS DATE_TO_PLANNED,
  TO_DATE(TO_CHAR(D.DATUM,'YYYYMMDD') || (CASE WHEN D.HOUR_FROM_PLANNED IS NULL THEN (SELECT VREDNOST FROM S_NASTAVITVE WHERE NAZIV = 'WorkerTimesheetTimeFrom') ELSE D.HOUR_FROM_PLANNED END), 'YYYYMMDDHH24:MI') AS DATE_FROM_ACTUAL,
  TO_DATE(TO_CHAR(D.DATUM,'YYYYMMDD') || (CASE WHEN D.HOUR_FROM_PLANNED IS NULL THEN (SELECT VREDNOST FROM S_NASTAVITVE WHERE NAZIV = 'WorkerTimesheetTimeFrom') ELSE D.HOUR_FROM_PLANNED END), 'YYYYMMDDHH24:MI') + D.STEVILO_UR/24 AS DATE_TO_ACTUAL
  FROM DELAVCI D
  LEFT OUTER JOIN M_STORITVE MS ON MS.ID_STORITVE = D.ID_STORITVE
  LEFT OUTER JOIN M_NNSTOMAR MNS ON MNS.SIFRA = MS.STORITEV
  LEFT OUTER JOIN NNDELAVC ND ON ND.SIFRA = D.SIFRA
  LEFT OUTER JOIN KUPCI KD ON KD.ID = ND.ID_LASTNIKA
  LEFT OUTER JOIN TIPSERVIS TS ON TS.SIFRA = D.ID_TIPSERVIS
  LEFT OUTER JOIN MAINTENANCE_TASK MT ON MT.ID_STORITVE = D.ID_STORITVE
  LEFT OUTER JOIN WORKER_TASK_STATUS TSP ON TSP.ID_WORKER_TASK_STATUS = D.STATUS_PLAN
  LEFT OUTER JOIN WORKER_TASK_STATUS TSA ON TSA.ID_WORKER_TASK_STATUS = D.STATUS_ACTUAL
);

insert into verzije_baza
(id, dt_vpis, verzija, ver_nr, opis) values (1529, SYSDATE, '5.5', 1449, 'Workers')
;
